<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2009 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: autonews_admin.php (autonews v1.1)
| Author: flj (Flemming Jensen)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";
require_once INFUSIONS."autonews/autonews_include.php";

if (!checkrights("AN") || !defined("iAUTH") || $_GET['aid'] != iAUTH) redirect("../index.php");

// Default settings and drop-down options - if changing default be careful to ensure it's in ..._opts array as well and also to change DEFAULT value in infusion.php
$frequency_default = 604800;
$frequency_opts = array(
      3600 => $locale['AN376'],
      7200 => "2. ".$locale['AN376'],
     14400 => "4. ".$locale['AN376'],
     28800 => "8. ".$locale['AN376'],
     43200 => "12. ".$locale['AN376'],
     86400 => $locale['AN377'],
    172800 => "2. ".$locale['AN377'],
    259200 => "3. ".$locale['AN377'],
    345600 => "4. ".$locale['AN377'],
    432000 => "5. ".$locale['AN377'],
    518400 => "6. ".$locale['AN377'],
    604800 => $locale['AN378'],
   1209600 => "2. ".$locale['AN378'],
   1814400 => "3. ".$locale['AN378'],
   2419200 => $locale['AN379'],
   5184000 => "2. ".$locale['AN379'],
   7776000 => "3. ".$locale['AN379'],
  10368000 => "4. ".$locale['AN379'],
  12960000 => "5. ".$locale['AN379'],
  15552000 => "6. ".$locale['AN379'],
  23328000 => "9. ".$locale['AN379'],
  31104000 => "12. ".$locale['AN379']);

$maxlen_default = 40; // Max length of comments (for use with trimlink(..., $maxlen))
$maxlen_opts = array(20, 30, 40, 50, 60, 70, 80, 90, 100);

$minno_default = 1; // Min number of comments (not send if less))
$minno_opts = array(1, 2, 5, 10);

$maxno_default = 20; // Max number of comments (truncated if more)
$maxno_opts = array(5, 10, 20, 30, 40, 50);

$chunksize_default = 50; // No of persons to send to at a time (to avoid delays/timeout)
$chunksize_opts = array(10, 20, 50, 100, 200, 500, 1000);
  
$senddelay_default = 300; // Min no of seconds between to mail sendings (to avoid delays/timeout)
$senddelay_opts = array(
    60 => "1 ".$locale['AN371'],
   120 => "2 ".$locale['AN372'],
   300 => "5 ".$locale['AN372'],
   900 => "15 ".$locale['AN372'],
  1800 => "30 ".$locale['AN372'],
  3600 => "60 ".$locale['AN372']);

$autonews_settings = autonews_readdb();

if (isset($_POST['save_autonews']))                              
{
  $autonews_settings['frequency'] = verify_num_array($_POST['frequency'], $frequency_opts, $frequency_default, TRUE);

  $include = bit_init();
	
	if (isset($_POST['include_0'])) bit_set($include, 0);
	  
  foreach ($autonews_data as $item)
  {
    if (isset($_POST['include_'.$item['id']])) bit_set($include, $item['id']);
  }		
  $autonews_settings['include'] = $include;

  $autonews_settings['maxlen'] 				= verify_num_array($_POST['maxlen'], 		$maxlen_opts, 		$maxlen_default);
  $autonews_settings['minno'] 				= verify_num_array($_POST['minno'], 		$minno_opts, 			$minno_default);
  $autonews_settings['maxno'] 				= verify_num_array($_POST['maxno'], 		$maxno_opts, 			$maxno_default);
  $autonews_settings['banner_top'] 		= trim($_POST['banner_top']);
  $autonews_settings['banner_bottom']	= trim($_POST['banner_bottom']);
  $autonews_settings['chunksize'] 		= verify_num_array($_POST['chunksize'],	$chunksize_opts, $chunksize_default);
  $autonews_settings['senddelay'] 		= verify_num_array($_POST['senddelay'], $senddelay_opts, $senddelay_default, TRUE);

  autonews_writedb($autonews_settings);
}

// Begin
opentable($locale['AN300']);

$err = 0;
if (dbcount("(field_id)", DB_USER_FIELDS, "field_name = 'user_autonews'") != 1) $err = $err + 1;
if (dbcount("(panel_id)", DB_PANELS, "panel_filename = 'autonews_panel' AND panel_type = 'file' AND panel_status = '1'") != 1) $err = $err + 2;

if ($err == 0)
{
  
  echo("<form name='autonews' method='post' action='".FUSION_SELF.$aidlink."'>\n");
  echo("<table cellpadding='0' cellspacing='0' width='700' class='center'>\n");

  // frequency
  dropdownbox(TRUE, $locale['AN301'], '', 'frequency', $autonews_settings['frequency'], $frequency_opts);

  // disabled (include - bit 0)
  checkbox($locale['AN302'], '', 'include_0', bit_isset($autonews_settings['include'], 0));

  // include
  echo("<tr>\n<td width='1%' class='tbl' style='white-space:nowrap' colspan='2'>".$locale['AN303'].":</td>\n</tr>\n");
  foreach ($autonews_data as $item)
  {
    checkbox('', $item['type'], "include_".$item['id'], bit_isset($autonews_settings['include'], $item['id']));
  }

  // maxlen
  dropdownbox(FALSE, $locale['AN304'], " ".$locale['AN305'], 'maxlen', $autonews_settings['maxlen'], $maxlen_opts);

  // minno
  dropdownbox(FALSE, $locale['AN306'], " ".$locale['AN307'], 'minno', $autonews_settings['minno'], $minno_opts);

  // maxno
  dropdownbox(FALSE, $locale['AN308'], " ".$locale['AN307'], 'maxno', $autonews_settings['maxno'], $maxno_opts);

  // banner_top
  textbox($locale['AN309'], '', 'banner_top', $autonews_settings['banner_top']);

  // banner_bottom
  textbox($locale['AN310'], '', 'banner_bottom', $autonews_settings['banner_bottom']);

  // chunksize
  dropdownbox(FALSE, $locale['AN311'], " ".$locale['AN312'], 'chunksize', $autonews_settings['chunksize'], $chunksize_opts);

  // senddelay
  dropdownbox(TRUE, $locale['AN313'], " ".$locale['AN314'], 'senddelay', $autonews_settings['senddelay'], $senddelay_opts);

  // Buttons
  echo("<tr>\n<td class='tbl'></td>\n");
  echo("<td class='tbl'><input type='submit' name='save_autonews' value='".$locale['AN350']."' class='button' /></td>\n</tr>\n");
  echo("</td>\n</tr>\n");

  // Test
  echo("<tr>\n<td class='tbl'>".$locale['AN360']."</td>\n");
  echo("<td class='tbl'><a href='".INFUSIONS."autonews/autonews_view.php".$aidlink."&test=1' target='_blank'>".$locale['AN391']."</a></td>\n</tr>\n");
  echo("<tr>\n<td class='tbl'></td>\n");
  echo("<td class='tbl'><a href='".INFUSIONS."autonews/autonews_view.php".$aidlink."&test=0' target='_blank'>".$locale['AN392']."</a></td>\n</tr>\n");
  echo("<tr>\n<td class='tbl'></td>\n");
  echo("<td class='tbl'><a href='".INFUSIONS."autonews/autonews_subscribe.php".$aidlink."&s=0&r=".INFUSIONS."autonews/autonews_admin.php".$aidlink."&uid=all'>".$locale['AN393']."</a></td>\n</tr>\n");

  // End
  echo("</table>\n</form>\n");
}
else
{
  echo("<strong>".$locale['AN320']."</strong><br /><br />\n");
  if ($err%2 == 1) echo(sprintf($locale['AN321'], "<a href='".ADMIN."user_fields.php".$aidlink."'>".$locale['AN323']."</a>").".<br /><br />\n");
  if ($err > 1)    echo(sprintf($locale['AN322'], "<a href='".ADMIN."panels.php".$aidlink."'>".$locale['AN323']."</a>").".<br /><br />\n");
}

closetable();

require_once THEMES."templates/footer.php";

function checkbox($text1, $text2, $name, $value)
{
  echo("<tr>\n<td class='tbl'>".$text1."</td>\n");
  echo("<td class='tbl'><input type='checkbox' name='".$name."' class='checkbox' ".($value? "checked='checked'": "")." />".$text2."</td>\n</tr>\n");
}

function dropdownbox($usekey, $text1, $text2, $name, $value, $options)
{
  echo("<tr>\n<td width='1%' class='tbl' style='white-space:nowrap'>".$text1."</td>\n");
  echo("<td class='tbl'><select name='".$name."' class='textbox' />");
  foreach ($options as $key => $item)
  {
    echo("<option value='".($usekey? $key: $item)."'");
    if ($value == ($usekey? $key: $item)) echo(" selected ");
    echo(">".$item."</option>");
  }
  echo("</select>".$text2."</td>\n</tr>\n");
}

function textbox($text1, $text2, $name, $value)
{
  echo("<tr>\n<td class='tbl'>".$text1."</td>\n");
  echo("<td class='tbl'><input type='text' name='".$name."' value='".$value."' class='textbox' style='width:200px;' />".$text2."</td>\n</tr>\n");
}

function verify_num_array($post, $array, $default, $key = FALSE)
{
	if ($key)
	{	
  	return isnum($post) && array_key_exists($post, $array)? $post: $default;
  }
  else
  {
  	return isnum($post) && in_array($post, $array)? $post: $default;
  }
}
?>