<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2009 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: autonews_data.php (autonews v1.1)
| Author: flj (Flemming Jensen)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

$ts_cut = ($autonews_settings['ts_lastsend'] == 0? time() - $autonews_settings['frequency']: $autonews_settings['ts_lastsend']); 
$autonews_data = array(
  // News
  1 => array(
    'id'    => 1,
    'type'  => $locale['AN511'],
    'text'  => $locale['AN512'],
    'type1' => $locale['AN513'],
    'type2' => $locale['AN514'],
    'parse1'=> 'return pagelink(\'N\', $data[\'item_id\'], trimlink($data[\'item_text\'], $autonews_settings[\'maxlen\']));',
    'parse2'=> '',
    'query' => "SELECT  news_datestamp AS timestamp, 
                        user_id, 
                        user_name, 
                        news_id AS item_id, 
                        0 AS item_no, 
                        news_subject AS item_text,
                        0 AS item2_id, 
                        0 AS item2_no, 
                        '' AS item2_text 
                				FROM ".DB_NEWS." 
                				LEFT JOIN ".DB_USERS." ON (news_name = user_id) 
                        WHERE 
													(news_visibility='0' OR news_visibility='101') AND (news_start='0' OR news_start<=".time().") AND (news_end='0' OR news_end>=".time().") AND news_draft='0' AND
													news_datestamp > ".$ts_cut.";"
  ),
  // Articles
  2 => array(
    'id'    => 2,
    'type'  => $locale['AN521'],
    'text'  => $locale['AN522'],
    'type1' => $locale['AN523'],
    'type2' => $locale['AN524'],
    'parse1'=> 'return pagelink(\'A\', $data[\'item_id\'], trimlink($data[\'item_text\'], $autonews_settings[\'maxlen\']));',
    'parse2'=> '',
    'query' => "SELECT  article_datestamp AS timestamp,
                        user_id, 
                        user_name, 
                        article_id AS item_id, 
                        0 AS item_no,
                        article_subject AS item_text,
                        0 AS item2_id, 
                        0 AS item2_no, 
                        '' AS item2_text 
                        FROM ".DB_ARTICLES." 
                        LEFT JOIN ".DB_USERS." ON (article_name = user_id)
												LEFT JOIN ".DB_ARTICLE_CATS." ON (article_cat = article_cat_id) 
                        WHERE 
													".useraccess('article_cat_access')." AND article_draft='0' AND
													article_datestamp > ".$ts_cut.";"
  ),
  // Photoalbums
  3 => array(
    'id'    => 3,
    'type'  => $locale['AN531'],
    'text'  => $locale['AN532'],
    'type1' => $locale['AN533'],
    'type2' => $locale['AN534'],
    'parse1'=> 'return pagelink(\'PA\', $data[\'item_id\'], trimlink($data[\'item_text\'], $autonews_settings[\'maxlen\']));',
    'parse2'=> '',
    'query' => "SELECT  album_datestamp AS timestamp, 
                        user_id, 
                        user_name, 
                        ta.album_id AS item_id, 
                        count(photo_id) AS item_no, 
                        album_title AS item_text,
                        0 AS item2_id, 
                        0 AS item2_no, 
                        '' AS item2_text 
                        FROM ".DB_PHOTO_ALBUMS." AS ta 
                        LEFT JOIN ".DB_USERS." AS tu ON (album_user = user_id) 
                        LEFT JOIN ".DB_PHOTOS." AS tp ON (ta.album_id = tp.album_id) 
                        WHERE 
													".useraccess('album_access')." AND
													album_datestamp > ".$ts_cut." 
                        GROUP BY ta.album_id;"
  ),
  // Photos
  4 => array(
    'id'    => 4,
    'type'  => $locale['AN541'],
    'text'  => $locale['AN542'],
    'type1' => $locale['AN543'],
    'type2' => $locale['AN544'],
    'parse1'=> 'return pagelink(\'PA\', $data[\'item_id\'], trimlink($data[\'item_text\'], $autonews_settings[\'maxlen\']));',
    'parse2'=> 'return pagelink(\'P\', $data[\'item2_id\'], trimlink($data[\'item2_text\'], $autonews_settings[\'maxlen\']));',
    'query' => "SELECT  MIN(photo_datestamp) AS timestamp, 
                        user_id, 
                        user_name, 
                        ta.album_id AS item_id, 
                        count(*) AS item_no, 
                        album_title AS item_text, 
                        MIN(photo_id) as item2_id, 
                        0 AS item2_no, 
                        '".$locale['AN545']."' AS item2_text 
                        FROM ".DB_PHOTOS." AS tp 
                        LEFT JOIN ".DB_PHOTO_ALBUMS." AS ta ON (ta.album_id = tp.album_id) 
                        LEFT JOIN ".DB_USERS." AS tu ON (photo_user = user_id)    
                        WHERE
													".useraccess('album_access')." AND
													photo_datestamp > ".$ts_cut."
                        GROUP BY ta.album_id, photo_user
                        HAVING item_no > 0;"                                               
  ),
  // Threads
  5 => array(
    'id'    => 5,
    'type'  => $locale['AN551'],
    'text'  => $locale['AN552'],
    'type1' => $locale['AN553'],
    'type2' => $locale['AN554'],
    'parse1'=> 'return pagelink(\'FT\', $data[\'item_id\'], trimlink($data[\'item_text\'], $autonews_settings[\'maxlen\']));',
    'parse2'=> 'return pagelink(\'FF\', $data[\'item2_id\'], trimlink($data[\'item2_text\'], $autonews_settings[\'maxlen\']));',
    'query' => "SELECT	MIN(post_datestamp) as timestamp, 
												user_id,
												user_name,
												thread_id AS item_id, 
												COUNT(post_datestamp) AS item_no, 
												thread_subject AS item_text,
												tf.forum_id AS item2_id,
												0 AS item2_no,
												CONCAT(t2.forum_name, ': ', tf.forum_name) AS item2_text
												FROM ".DB_THREADS." AS tt
												LEFT JOIN ".DB_USERS." AS tu ON(thread_author=user_id)
												LEFT JOIN ".DB_POSTS." AS tp USING(thread_id)
												LEFT JOIN ".DB_FORUMS." AS tf ON(tf.forum_id=tt.forum_id)
												LEFT JOIN ".DB_FORUMS." AS t2 ON (tf.forum_cat=t2.forum_id)
												WHERE ".useraccess('tf.forum_access')."
												GROUP BY thread_id
												HAVING
												  timestamp > ".$ts_cut.";"
	),
	// Posts
  6 => array(
    'id'    => 6,
    'type'  => $locale['AN561'],
    'text'  => $locale['AN562'],
    'type1' => $locale['AN563'],
    'type2' => $locale['AN564'],
    'parse1'=> 'return pagelink(\'FT\', $data[\'item_id\'], trimlink($data[\'item_text\'], $autonews_settings[\'maxlen\']));',
    'parse2'=> 'return pagelink(\'FF\', $data[\'item2_id\'], trimlink($data[\'item2_text\'], $autonews_settings[\'maxlen\']));',
    'query' => "SELECT	post_datestamp as timestamp, 
												user_id,
												user_name,
												thread_id AS item_id, 
												COUNT(post_datestamp) AS item_no, 
												thread_subject AS item_text,
												tf.forum_id AS item2_id,
												0 AS item2_no,
												CONCAT(t2.forum_name, ': ', tf.forum_name) AS item2_text
												FROM ".DB_POSTS." AS tp
												LEFT JOIN ".DB_USERS." AS tu ON(post_author=user_id)
												LEFT JOIN ".DB_THREADS." AS tt USING(thread_id)
												LEFT JOIN ".DB_FORUMS." AS tf ON(tf.forum_id=tt.forum_id)
												LEFT JOIN ".DB_FORUMS." AS t2 ON (tf.forum_cat=t2.forum_id)
												WHERE 
                          ".useraccess('tf.forum_access')." AND
												  post_datestamp > ".$ts_cut."
												GROUP BY thread_id, user_id
												HAVING
													item_no > 0;"                                           
	),
	// Threads and posts (summary)
  7 => array(
    'id'    => 7,
    'type'  => $locale['AN571'],
    'text'  => $locale['AN572'],
    'type1' => '',
    'type2' => '',
    'parse1'=> '',
    'parse2'=> '',
    'query' => "SELECT	UNIX_TIMESTAMP() as timestamp, 
												0 AS user_id,
												'' AS user_name,
												0 AS item_id, 
												COUNT(*) AS item_no, 
												'' AS item_text,
												0 AS item2_id,
												COUNT(DISTINCT thread_id) AS item2_no,
												'' AS item2_text
												FROM ".DB_POSTS." AS tp
												LEFT JOIN ".DB_FORUMS." AS tf ON(tf.forum_id=tp.forum_id)
												WHERE 
													".useraccess('tf.forum_access')." AND
												  post_datestamp > ".$ts_cut."
                        HAVING item_no > 0;"
	),
  // Downloads
  8 => array(
    'id'    => 8,
    'type'  => $locale['AN581'],
    'text'  => $locale['AN582'],
    'type1' => $locale['AN583'],
    'type2' => $locale['AN584'],
    'parse1'=> 'return pagelink(\'D\', $data[\'item_id\'], trimlink($data[\'item_text\'], $autonews_settings[\'maxlen\']));',
    'parse2'=> 'return $data[\'item2_text\'];',
    'query' => "SELECT  download_datestamp AS timestamp, 
                        0 AS user_id, 
                        '' AS user_name, 
                        download_cat_id AS item_id, 
                        0 AS item_no, 
                        download_title AS item_text,
                        0 AS item2_id, 
                        0 AS item2_no, 
                        download_cat_name AS item2_text 
                        FROM ".DB_DOWNLOADS." 
                        LEFT JOIN ".DB_DOWNLOAD_CATS." ON (download_cat_id=download_cat) 
                        WHERE 
													".useraccess('download_cat_access')." AND
													download_datestamp > ".$ts_cut.";"
	),
  // Weblinks
  9 => array(
    'id'    => 9,
    'type'  => $locale['AN591'],
    'text'  => $locale['AN592'],
    'type1' => $locale['AN593'],
    'type2' => $locale['AN594'],
    'parse1'=> 'return pagelink(\'W\', $data[\'item_id\'], trimlink($data[\'item_text\'], $autonews_settings[\'maxlen\']));',
    'parse2'=> 'return $data[\'item2_text\'];',
    'query' => "SELECT  weblink_datestamp AS timestamp, 
                        0 AS user_id, 
                        '' AS user_name, 
                        weblink_cat_id AS item_id, 
                        0 AS item_no, 
                        weblink_name AS item_text,
                        0 AS item2_id, 
                        0 AS item2_no, 
                        weblink_cat_name AS item2_text 
                        FROM ".DB_WEBLINKS." 
                        LEFT JOIN ".DB_WEBLINK_CATS." ON (weblink_cat_id=weblink_cat) 
                        WHERE 
													".useraccess('weblink_cat_access')." AND
													weblink_datestamp > ".$ts_cut.";"
	),
  // Comments
  10 => array(
    'id'    => 10,
    'type'  => $locale['AN601'],
    'text'  => $locale['AN602'],
    'type1' => $locale['AN603'],
    'type2' => $locale['AN604'],
    'parse1'=> 'return pagelink($data[\'item_no\'], $data[\'item_id\'], trimlink(parseubb(str_replace(\'\n\', \'\', $data[\'item_text\'])), $autonews_settings[\'maxlen\']));',
    'parse2'=> 'return $data[\'item_no\'] == \'A\'? $locale[\'AN606\']: ($data[\'item_no\'] == \'N\'? $locale[\'AN605\']: $locale[\'AN607\']);',
    'query' => "SELECT  comment_datestamp AS timestamp, 
                        comment_name AS user_id,
                        user_name,
                        comment_item_id AS item_id, 
                        comment_type AS item_no,
                        comment_message AS item_text,
                        0 AS item2_id, 
                        0 AS item2_no, 
                        '' AS item2_text 
                        FROM ".DB_COMMENTS." 
                        LEFT JOIN ".DB_USERS." ON (comment_name = user_id)
												LEFT JOIN ".DB_NEWS." ON (comment_item_id = news_id) 
												LEFT JOIN ".DB_ARTICLES." ON (comment_item_id = article_id) 
												LEFT JOIN ".DB_ARTICLE_CATS." ON (article_cat = article_cat_id) 
                        LEFT JOIN ".DB_PHOTOS." ON (comment_item_id = photo_id)
												LEFT JOIN ".DB_PHOTO_ALBUMS." USING (album_id) 
                        WHERE 
													(
														(".(bit_isset($autonews_settings['include'], 1)? 1: 0)." AND comment_type = 'N' AND (news_visibility='0' OR news_visibility='101') AND (news_start='0' OR news_start<=".time().") AND (news_end='0' OR news_end>=".time().") AND news_draft='0') OR 
														(".(bit_isset($autonews_settings['include'], 2)? 1: 0)." AND comment_type = 'A' AND ".useraccess('article_cat_access')." AND article_draft='0') OR
														(".(bit_isset($autonews_settings['include'], 4)? 1: 0)." AND comment_type = 'P' AND ".useraccess('album_access').")
													) AND
												  comment_datestamp > ".$ts_cut.";"
  ),
  // Users
  11 => array(
    'id'    => 11,
    'type'  => $locale['AN611'],
    'text'  => $locale['AN612'],
    'type1' => $locale['AN613'],
    'type2' => $locale['AN614'],
    'parse1'=> 'return $settings[\'sitename\'];',
    'parse2'=> '',
    'query' => "SELECT  user_joined AS timestamp, 
                        user_id, 
                        user_name, 
                        0 AS item_id, 
                        0 AS item_no, 
                        '' AS item_text,
                        0 AS item2_id, 
                        0 AS item2_no, 
                        '' AS item2_text 
                				FROM ".DB_USERS." 
                        WHERE 
													user_joined > ".$ts_cut.";"
  ),
	// Users (summary)
  12 => array(
    'id'    => 12,
    'type'  => $locale['AN621'],
    'text'  => $locale['AN622'],
    'type1' => '',
    'type2' => '',
    'parse1'=> 'return $settings[\'sitename\'];',
    'parse2'=> '',
    'query' => "SELECT  UNIX_TIMESTAMP() AS timestamp, 
                        0 AS user_id, 
                        '' AS user_name, 
                        0 AS item_id, 
                        COUNT(user_id) AS item_no, 
                        '' AS item_text,
                        0 AS item2_id, 
                        0 AS item2_no, 
                        '' AS item2_text 
                				FROM ".DB_USERS." 
                        WHERE 
													user_joined > ".$ts_cut."
                        HAVING item_no > 0;"
  ),
  // Shoutbox
  13 => array(
    'id'    => 13,
    'type'  => $locale['AN631'],
    'text'  => $locale['AN632'],
    'type1' => $locale['AN633'],
    'type2' => $locale['AN634'],
    'parse1'=> 'return pagelink(\'S\', 0, trimlink($data[\'item_text\'], $autonews_settings[\'maxlen\']));',
    'parse2'=> '',
    'query' => "SELECT  shout_datestamp AS timestamp, 
                        shout_name AS user_id, 
                        user_name, 
                        0 AS item_id, 
                        0 AS item_no, 
                        shout_message AS item_text,
                        0 AS item2_id, 
                        0 AS item2_no, 
                        '' AS item2_text 
                				FROM ".DB_SHOUTBOX." 
                				LEFT JOIN ".DB_USERS." ON (shout_name = user_id) 
                        WHERE 
													shout_datestamp > ".$ts_cut.";"
  ),
);
?>
      